/*->c.!convert */


/***************************************************************************

Version 1.04  10/07/96
----------------------
Style names truncated to 16 characters.

Version 1.05  27/08/96
----------------------
First style found is now named "BodyText" (instead of renaming "Normal" to
"BodyText").

Fixed problem where style names that are 15 characters long are terminated
with an extra double quote character.

Version 1.06
------------
Explicit style names are used so that tagged text without style definitions
can be converted. Needs Ovation Pro 2.37.

Fixed problem importing DDF's generated by TableMate (commands could end
with ; or } but not with the ;} sequence).

Version 1.07
------------
Styles now always output before any text. This version is now compatible
with !UnHTML.

***************************************************************************/



#include "stdafx.h"

#include <setjmp.h>

#include "windows.h"


#include "os.h"
#include "fsx.h"
#include "etc.h"

#include "convert.h"
#include "comlist.h"

char *start, *end, *p;
FILE *out;

int ddfoff;
int ddfliteral;          /* set if get() got something in quotes */
char s[BUFFSIZE];

int ls[MAXSTYLES];
int styletot = 0;
int styleno = 0, colno = 0, cts;
int scope, leoff, def;
int beffect, ieffect;
double li = 0;
char f[255];
char *st[MAXSTYLES], *ct[MAXCOLS];





static jmp_buf xraisejmp;


/* Main loop */

int main(int argc, char *argv[])
{
 int pass;
 int result;

 result=setjmp(xraisejmp);
 if(!result)
 {
  checkargs(argc);
  loadddf(argv[1]);
  openout(argv[2]);

  for(pass = 1; pass <= 3; ++pass)
  {
   ddfoff = 0;
   p = start;
   while (p < end)
   {
    if(pass != 3)
    {
     if (*p == '{')
     {
      if(pass == 1)
       scan();
       else
       scan2();
     }
     ++p;
    }
    else
    {
     if (*p != '{')
      text();
     else
     {
      commands();
      ++p;
     }
    }
   }
   if(pass == 1 && colno)
    outputcolourtable();
   if(pass == 2)
    fprintf(out, "STORY_1={story");
  }
  fprintf(out, "{endoftext}\r\n}\r\n");

  fclose(out);
 }

 return(result);
}



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

 return(main(__argc,__argv));

 USE(hInstance);
 USE(nCmdShow);
 USE(lpCmdLine);
 USE(hPrevInstance);
}





/* Check arguments */

void checkargs(int n)
{
 if (n != 3)
 {
  error("Syntax: TransDDF <DDF name> <DDL name>");
 }
}


/* Load the DDF file */

void loadddf(char *f) 
{
 FILE *in;
 fstat fs;

 if ((in = fopen(f, "rb")) == NULL)
  error("Cannot open input file.");

 fs_stat(f,&fs);

 if((start = (char *) malloc(fs.length)) == NULL)
  error("Not enough memory to load input file");

 if ((fread(start, sizeof(char), fs.length,in)) != (unsigned)fs.length)
  error("Cannot load input file.");
 end = start + fs.length;

 fclose(in);
}


/* Print error messages */

void error(char *err)
{
 ATOM atom;
 
 atom=GlobalAddAtom(err);
 
 longjmp(xraisejmp,(int)atom);
}



/* Open the output file */

void openout(char *f)
{
 if((out=fopen(f,"wb"))==NULL) error("Cannot open output file.");
}


/* Handle plain text */

void text(void)
{
 int i = 0;

 while (*p != 9 && *p != 10 && *p != 13 && *p != '{' && i < (BUFFSIZE - 2) && p != end)
 {
  if (*p == '\\' || *p == '\"')
   s[i++] = '\\';
  s[i++] = *p++;
 }
 s[i]='\0';
 if (i)
  fprintf(out, "\r\n\"%s\"", s);
 if (*p == 9 || *p == 10 || *p == 13)
 {
  if(*p == 9)
   tab();
  else
   newpara();
  ++p;
 }
}


/* Deal with {on}, {off}, count styles, map local styles and output colours */

void scan(void)
{
 int sp;

 sp=0; /* compiler */

 while (*p != '}' && p != end)
 {             
  getword();
  if (!strcmp("on", s))
   ddfoff = 0;
  if (!strcmp("off", s))
   ddfoff = 1;
  if(ddfoff)
   break;

  if (!strcmp("define", s))
  {
   sp = (int)p;
   getword();
   if (!strcmp("colours", s))
    namedcolours();
   else
   {
    if (styletot == MAXSTYLES)
     error("Too many styles");
    ls[styletot++] = 0;
   }
  }
  if (!strcmp("effectruler", s) && !strcmp("on", getword()))
   ls[styletot - 1] = sp;
  else
  if (!strcmp("fontcolour", s) || !strcmp("backcolour", s))
   addcolourtotable();
  else
   skipcommand();
 }
}


/* Deal with styles */

void scan2(void)
{
 while (*p != '}' && p != end)
 {             
  getword();
  if (!strcmp("on", s))
   ddfoff = 0;
  if (!strcmp("off", s))
   ddfoff = 1;
  if(ddfoff)
   break;

  if(!strcmp("define", s))
   definestyle();
  else
   skipcommand();
 }
}

void commands(void)
{
 char *lp;
 int i;

 i=0; /* compiler */

 while (*p != '}' && p != end)
 {
  lp = p;
  getword();

  if(!ddfliteral)
  {
   i=0;
   while(strcmp(com[i].name,"end") && strcmp(com[i].name,s))
   i++;

   if(!strcmp("on",s) || !strcmp("off",s))
   {
    ddfoff=!strcmp("off",s);
    break;
   }
  }

  if(!ddfliteral && s[0]=='\\' && !ddfoff) code();
  else
  if(!ddfliteral && strcmp(com[i].name,"end") && !ddfoff) com[i].func();
  else
  {
   if(style())
   {
    fprintf(out, "\"{\"");
    p = lp;
    break;
   }
  }
 }
}


char *getword(void)
{
  return get(" ;}", 1);
}

char *getwords(void)
{
  return get(";},", 1);
}

char *gettab(void)
{
  return get(" ;},", 1);
}

char *gettocr(void)
{
  return get("\n", 0);
}

char *get(char *term, int lc)
{
  int i = 0;
  char *temp;

  ++p;
  skipwhitespace();
  if(*p!='\"')
  {
   while (!strchr(term, *p) && p != end && i < BUFFSIZE)
      s[i++] = lc ? tolower(*p++) : *p++;

   ddfliteral=0;
  }
  else
  {
   ++p;
   while(*p != '\"')
    s[i++] = *p++;
   ++p;
   ddfliteral=1;
  }
  s[i]='\0';

  if (*p == ' ' || *p == '\n' || *p=='\r')
  {
    skipwhitespace();
    if (!strchr(term, *p))
      --p;
  }
  temp=p;
  if(*p==';')
  {
   while(*p==10 || *p==13 || *p==' ' || *p==';' && p!=end) ++p;
   if(*p!='}') p=temp;
  }
  return s;
}

void skipcommand(void)
{
 char *temp;

  while(*p != '}' && *p != ';' && p != end)
    ++p;
  temp = p;
  if(*p==';')
  {
   while(*p==10 || *p==13 || *p==' ' || *p==';' && p!=end)
    ++p;
   if(*p != '}')
    p = temp;
  }

}


void skipwhitespace(void)
{
 while(*p==10 || *p==13 || *p==' ' && p!=end) p++;
}


void definestyle(void)
{
  if (strcmp("colours", getword()))
  {
   def = 1;
   scope = 0;
   beffect = -1; ieffect = -1;
   getword();

/*   if(strlen(s) > 18)
   {
    s[17] = '\"';
    s[18] = '\0';
   } */


   if(strlen(s)>18)
   {
    s[18] = '\0';
   }


    if ((st[styleno] = (char *) malloc(strlen(s) + 1)) == NULL)
      error("Not enough memory for Styles");
    strcpy(st[styleno], s);
    if (ls[styleno])
      while(*p != '}') ++p;
    else
    {
      fprintf(out, "STYLE_%d={style \"%s\"\r\n", styleno, styleno ? s : "BodyText");

      commands();

      fprintf(out, "{keypress %s}", styleno ? "\"\"" : "\"C_F1\"");
      fprintf(out, "{scope %d}\r\n}\r\n\r\n", scope);
    }
    ++styleno;
    def = 0;
    beffect = -1; ieffect = -1;
  }
  else
    skipcommand();
}


void namedcolours(void)
{
  int i;
  char m[24];
  char n[24];
  char *pp, *e;

  while (*(p+1) != '}' && p != end)
  {
    getword();
    strcpy(m, "");
    if (!strcmp("%%+c", s)) strcpy(m, "cmyk");
    if (!strcmp("%%+r", s)) strcpy(m, "rgb");
    if (!strcmp("%%+h", s)) strcpy(m, "hsv");
    if (strcmp("", m))
    {
      getword();
      ++p;
      gettocr();
      i = strcspn(s, ")");
      strncpy(n, s, i > 23 ? 23 : i);
      n[i] = '\0';
      fprintf(out, "COL_%d={colour \"%s\" {%s", colno, n, m);
      insertcolour(n);
      pp = s + i + 2;
      for (i = 0; i < (signed)strlen(m); i++, pp = e + 1)
        fprintf(out, " 0x%x", (int)(strtod(pp, &e) * 0x10000 / (strcmp("hsv", m) ? 1 : 100)));
      fprintf(out, "}}\r\n");
    }
    else 
    if (!strcmp("%%+t", s))
    {
      ++p;
      gettocr();
      i = strcspn(s, ")");
      strncpy(n, s, i > 23 ? 23 : i);
      n[i] = '\0';
      /*fprintf(out, "COL_%d={colour \"%s\" {", colno, n);*/
      insertcolour(n);
      strcpy(m, n);
      if(e == strchr(n, '%'))
        strcpy(m, e);
    }
    else
    gettocr();
  }
  fprintf(out, "\r\n");
  cts = colno;
}

void addcolourtotable(void)
{
  int i;

  if (*p!='}')
  {
    getword();
    if (s[0] != '\"')
    {
     for(i=0;colno>0 && i<colno && strcmp(ct[i],s);i++);
     if(i==colno) insertcolour(s);
    }
  }
}

void insertcolour(char *c)
{
  if (colno == MAXCOLS)
    error("Too many colours");
  if ((ct[colno] = (char *) malloc(strlen(c) + 1)) == NULL)
    error("Not enough memory for Colours");
  strcpy(ct[colno++], c);
}

void outputcolourtable(void)
{
  int i, j, n;
  char m[6], temp[10];
  double mult;
  int c[4];
  char *pp, *e;

  for (i = cts; i < colno; i++)
  {
    strncpy(m, ct[i], j = strcspn(ct[i], "="));
    m[j] = '\0';
    if (strcmp("rgb", m) && strcmp("hsv", m) && strcmp("cmyk", m) && strcmp("rgb24", m))
      error("Colour model not recognised");
    n = strcmp("rgb24", m) ? strlen(m) : 4;

    pp = ct[i] + j + 2;
    strcpy(s, m);
    for (j = 0; j < n; j++, pp = e + 1)
    {
      mult = strcmp("rgb24", m) ? 100.0 : 100.0 / 256.0;
      sprintf(temp, "%d", c[j] = (int)(strtod(pp, &e) * mult));
      strcat(s, temp);
      if (j != n - 1) strcat(s, "/");
    }

    fprintf(out, "COL_%d={colour \"%s\" {%s", i, s, strcmp("rgb24", m) ? m : "rgb");
    for (j = 0; j < n; j++)
      fprintf(out, " 0x%x", (int)c[j] * 0x10000 / 100);
    fprintf(out, "}}\r\n");
  }
    fprintf(out, "\r\n");
}
